package maze.model.searchers;
import maze.searchers.Stack;

import java.util.ArrayList;

public class ArrayStack<E> implements Stack<E> {

	private ArrayList<E> stuff;

	public ArrayStack() {
		this(8);
	}

	public ArrayStack(int initialSize) {
		stuff = new ArrayList<E>(initialSize);
	}

	@Override
	public int size() {
		return stuff.size();
	}

	@Override
	public E pop() {
		return stuff.remove(size() - 1);
	}

	@Override
	public E peek() {
		notEmpty();
		return stuff.get(size() - 1);
	}

	@Override
	public void push(E e) {
		stuff.add(e);
	}

	@Override
	public String toString() {
		String s = "";
		for (int i = 0; i < size(); i++) {
			s += stuff.get(i) + " ";
		}
		return s;
	}

	@Override
	public int capacity() {
		// TODO Auto-generated method stub
		return stuff.size();
	}
}
