package maze.searchers;

public class WrappedQueue<T> implements Searcher<T> {
	private Queue<T> queue;
	
	public WrappedQueue(Queue<T> queue) {
		this.queue = queue;
	}

	@Override
	public int size() {
		return queue.size();
	}

	@Override
	public int capacity() {
		return queue.capacity();
	}

	@Override
	public T remove() {
		return queue.dequeue();
	}

	@Override
	public void add(T data) {
		queue.enqueue(data);
	}

	@Override
	public T peek() {
		return queue.lookAtHead();
	}

}
